# This file is responsable for creating the lists
import array
listHead = "**TI83F*\x1a\x0a\x00" #Create the list header (why didn't i put THE GAME in here?)
listHead += "List Created by Sorunome".ljust(42,"\x00")
def getTIReal(t1,t2,t3): #This will get the TI-real variable, based on the most stupid prozess ever known, i should make a better one once i have time
	if t1<=15:
		s = "\x00\x80"+str(chr(t1*16+t2))+str(chr(t3*16))+"\x00\x00\x00\x00\x00"
	elif t1<=255:
		s = "\x00\x81"+str(chr(t1))+"\x00\x00\x00\x00\x00\x00"
	else:
		s = "\x00\x82"+str(chr(int(str(t1/10),16))) + str(chr(int(str(t1-(t1/10)*10).ljust(2,'0'),16)))+"\x00\x00\x00\x00\x00"
	return s
def getChars(i): #returns the 2-byte little endian string of the integer passed
	return str(chr(int(hex(i)[2:].rjust(4,"0")[2:4],16))) + str(chr(int(hex(i)[2:].rjust(4,"0")[:2],16)))
def getBin(s): #tell me about optimized hex to bin conversion, the problem was that bin(int(hex('00'),16)) return 0 - not 00000000
	b=''
	for i in range(0,16):
		if s[i]=='0':
			b += '0000'
		elif s[i]=='1':
			b += '0001'
		elif s[i]=='2':
			b += '0010'
		elif s[i]=='3':
			b += '0011'
		elif s[i]=='4':
			b += '0100'
		elif s[i]=='5':
			b += '0101'
		elif s[i]=='6':
			b += '0110'
		elif s[i]=='7':
			b += '0111'
		elif s[i]=='8':
			b += '1000'
		elif s[i]=='9':
			b += '1001'
		elif s[i]=='A':
			b += '1010'
		elif s[i]=='B':
			b += '1011'
		elif s[i]=='C':
			b += '1100'
		elif s[i]=='D':
			b += '1101'
		elif s[i]=='E':
			b += '1110'
		elif s[i]=='F':
			b += '1111'
	return b
numberFiles = 0
for levelnum in range(1,7): #we only have 6 levels
	f = open('level'+str(levelnum)+'.txt')
	lines = f.readlines()
	f.close()
	n = 0
	listnum = 1
	s = ''
	for l in lines:
		n+=1
		data = l.split(',')
		mask = getBin(data[0])
		solve = getBin(data[1])
		for i in range(0,64): #there are 64 cells per puzzle
			#temp is the beginning state, temp2 is the solved state and temp3 is if it is changable
			if mask[i]=='1':
				temp = int(solve[i])
			else:
				temp = 2
			temp2 = int(solve[i])
			if mask[i]=='1':
				temp3 = 0
			else:
				temp3 = 1
			s += getTIReal(temp,temp2,temp3);
		if n==15:
			data = "\x0D\x00\xD4\x21\x01\x5DBPZD\x00\x00\x00\x00\x00\xD4\x21\xC2\x03"+getTIReal(levelnum,0,0)+getTIReal(listnum,0,0)+s #the whole data of the list
			file = listHead + getChars(len(data)) + data + getChars(int(str(sum(bytearray(data)))[:-2])) #finish the header and create a checksum
			f = open('level'+str(levelnum)+'/Data_Level'+str(levelnum)+'_Pack'+str(listnum).zfill(3)+'.8XL','w')
			print 'level'+str(levelnum)+'/Data_Level'+str(levelnum)+'_Pack'+str(listnum).zfill(3)+'.8XL'
			f.write(file) #create that file
			f.close()
			n = 0
			s = ''
			listnum += 1
			numberFiles += 1
print 'Total number files created:'+str(numberFiles)
print 'Total number puzzles created:'+str(numberFiles*15)
